#include "ocf/ocf.h"

#include "xcache_engine.h"
#include "xcache_engine_common.h"
#include "xcache_engine_rd.h"
#include "xcache_engine_wt.h"
#include "xcache_engine_wb.h"
#include "xcache_engine_flush.h"

void xcache_get_io_if(struct xcache_io *io, ocf_cache_mode_t mode)
{
	if (io->rw == OCF_WRITE) {
		switch (mode) {
			case ocf_cache_mode_wb:
				io->io_if = xcache_wb;
				return;
			case ocf_cache_mode_wt:
				io->io_if = xcache_wt;
				return;
			default:
				return;
		}
	} else if (io->rw == OCF_READ) {
		io->io_if = xcache_read_generic;
	} else {
		io->io_if = xcache_flush;
	}
}
