#ifndef XCACHE_ENGINE_FLUSH_H_
#define XCACHE_ENGINE_FLUSH_H_

#include "ocf/ocf.h"

extern env_atomic g_need_flush;

static inline void mark_flush(void)
{
	env_atomic_set(&g_need_flush, 1);
}

static inline void clear_flush(void)
{
	env_atomic_set(&g_need_flush, 0);
}

static inline bool need_flush(void)
{
	return (env_atomic_read(&g_need_flush) == 1);
}

int xcache_flush(struct xcache_io *io);

#endif
