#ifndef EVICTING_HELPER_H_
#define EVICTING_HELPER_H_

#include "../utils/utils_alock.h"
#include "../concurrency/ocf_cache_line_concurrency.h"
#include "../ocf_cache_priv.h"
#include "../metadata/metadata_status.h"

static inline bool evicting_test_dirty(xcache_context_t *ctx, xcache_line_t line)
{
	return metadata_test_dirty(ctx->cache, line);
}

static inline bool evicting_trylock_line(xcache_context_t *ctx, xcache_line_t line)
{
	struct ocf_alock *lock = ocf_cache_line_concurrency(ctx->cache);

	return ocf_alock_trylock_entry_wr(lock, line);
}

static inline void evicting_unlock_line(xcache_context_t *ctx, xcache_line_t line)
{
	struct ocf_alock *lock = ocf_cache_line_concurrency(ctx->cache);

	xcache_unlock_wr(lock, line);
}

static inline uint64_t evicting_line_num(xcache_context_t *ctx)
{
	return ctx->cache->device->collision_table_entries;
}
#endif
