#ifndef __XCACHE_METADATA_H__
#define __XCACHE_METADATA_H__

#include "ocf/ocf.h"
#include "metadata_raw.h"

#include "ocf/xcache.h"

void xcache_metadata_flush_asynch(struct ocf_cache *cache,
                struct ocf_metadata_io_context *io_ctx,
	       struct ocf_metadata_line_getter *line_getter);

int xcache_io_add_flush_line(struct xcache_io *io, ocf_cache_line_t line);
static inline void xcache_io_free_flush_line(struct xcache_io *io)
{
	if (io->flush_line_num <= INLINE_FLUSH_LINES) {
		return;
	}
	env_free(*(ocf_cache_line_t **)io->flush_lines);
}

static inline ocf_cache_line_t *get_inline_flush_lines(struct xcache_io *io)
{
	return io->flush_lines;
}

static inline ocf_cache_line_t *get_alloc_flush_lines(struct xcache_io *io)
{
	return *(ocf_cache_line_t **)io->flush_lines;
}

static inline ocf_cache_line_t *xcache_io_get_flush_line(struct xcache_io *io)
{
	if (io->flush_line_num <= INLINE_FLUSH_LINES) {
		return get_inline_flush_lines(io);
	} else {
		return get_alloc_flush_lines(io);
	}
}

static inline bool xcache_metadata_should_flush(struct xcache_io *io)
{
	return (env_atomic_read(&io->remaining) == 1);
}

void xcache_io_metadata_flush(struct xcache_io *io, ocf_metadata_io_ctx_end_t io_end);
#endif
