#include "xcache.h"
#include "evicting/evicting_ops.h"
#include "evicting/deadline.h"
#include "utils/utils_cache_line.h"

int xcache_init(ocf_cache_t cache)
{
	xcache_context_t *ctx = env_malloc(sizeof(xcache_context_t), 0);

	if (ctx == NULL) {
		return -1;
	}

	ctx->cache = cache;
	cache->xcache_ctx = ctx;

	set_deadline_policy();
	evicting_init(ctx);
	ctx->line_size_shift = __builtin_ffsll(ocf_line_size(cache)) - 1;
	xcache_qos_init(&ctx->qos);

	return 0;
}

void xcache_fini(ocf_cache_t cache)
{
	evicting_fini(cache->xcache_ctx);
	env_free(cache->xcache_ctx);
	cache->xcache_ctx = NULL;
}
