#ifndef XCACHE_QUEUE_H_
#define XCACHE_QUEUE_H_

#include "ocf/xcache.h"

#define QUEUE_CACHE_SIZE 128

struct xcache_queue_ctx {
	struct list_head backdev_io_list;
	int backdev_io_no;
	struct list_head flush_io_list;
	int flush_io_no;
	struct list_head xcache_io_list;
	int xcache_io_no;
	void *bf_data[QUEUE_CACHE_SIZE];
	int bf_data_num;
};

int xcache_queue_ctx_init(ocf_queue_t queue);
void xcache_queue_ctx_deinit(ocf_queue_t queue);
static inline struct xcache_queue_ctx *xcache_get_queue_ctx(ocf_queue_t queue)
{
	return (struct xcache_queue_ctx *)(queue->priv1);
}

struct xcache_backdev_io *xcache_queue_alloc_backdev_io(ocf_queue_t q);
void xcache_queue_free_backdev_io(ocf_queue_t q, struct xcache_backdev_io *io);
void xcache_queue_push_xcache_io_back(struct xcache_io *io, bool allow_sync);
void xcache_queue_push_backdev_io_front(struct xcache_backdev_io *base_io, bool allow_sync);
struct xcache_io *xcache_queue_alloc_xcache_io(ocf_queue_t q);
void xcache_queue_free_xcache_io(ocf_queue_t q, struct xcache_io *io);

ctx_data_t *xcache_queue_alloc_line_data(ocf_queue_t q, ocf_cache_t cache);
void xcache_queue_free_line_data(ocf_queue_t q, ocf_cache_t cache, ctx_data_t *data);
#endif
